Bug 148614 - Add support for the "unset" CSS property value
: Add support for the "unset" CSS property value
Status: RESOLVED FIXED
Product: WebKit
Classification: Unclassified
Component: CSS
: WebKit Nightly Build
: All All
: P2 Normal
Assigned To: Dave Hyatt
http://jsfiddle.net/cvrebert/1w6bhom0/
: HasReduction, InRadar
Depends on:
Blocks: 127616
  Show dependency treegraph
 
Reported: 2015-08-29 21:15 PDT by Chris Rebert
Modified: 2015-12-13 23:18 PST (History)
7 users (show)

See Also:


Attachments
Patch (47.78 KB, patch)
2015-10-15 15:15 PDT, Dave Hyatt
dino: review+
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Rebert 2015-08-29 21:15:46 PDT
It's part of CSS Cascading and Inheritance Level 3:
http://www.w3.org/TR/css-cascade-3/#inherit-initial

See also https://developer.mozilla.org/en-US/docs/Web/CSS/unset

Chrome and Firefox already support it, and it's "In Development" for Microsoft Edge.


Testcase: http://jsfiddle.net/cvrebert/1w6bhom0/

Testcase's HTML:
<div>A</div>
<div>B</div>
<div>C</div>

Testcase's CSS:
div {
    display: unset;/* in this case, same as inline */
}
Comment 1 Radar WebKit Bug Importer 2015-08-29 21:41:11 PDT
<rdar://problem/22491420>
Comment 2 Dave Hyatt 2015-10-15 15:15:23 PDT
Created attachment 263197 [details]
Patch
Comment 3 WebKit Commit Bot 2015-10-15 15:17:45 PDT
Attachment 263197 [details] did not pass style-queue:


ERROR: Source/WebCore/css/CSSValue.h:49:  enum members should use InterCaps with an initial capital letter.  [readability/enum_casing] [4]
ERROR: Source/WebCore/css/CSSValue.h:50:  enum members should use InterCaps with an initial capital letter.  [readability/enum_casing] [4]
Total errors found: 2 in 23 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 4 Dean Jackson 2015-10-15 15:30:28 PDT
Comment on attachment 263197 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=263197&action=review

> Source/WebCore/css/CSSParser.cpp:1951
> -
> +    

Oopsy.

> Source/WebCore/css/CSSUnsetValue.cpp:17
> + * Copyright (C) 2015 Apple Inc. All rights reserved.
> + *
> + * This library is free software; you can redistribute it and/or
> + * modify it under the terms of the GNU Library General Public
> + * License as published by the Free Software Foundation; either
> + * version 2 of the License, or (at your option) any later version.
> + *
> + * This library is distributed in the hope that it will be useful,
> + * but WITHOUT ANY WARRANTY; without even the implied warranty of
> + * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
> + * Library General Public License for more details.
> + *
> + * You should have received a copy of the GNU Library General Public License
> + * along with this library; see the file COPYING.LIB.  If not, write to
> + * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
> + * Boston, MA 02110-1301, USA.

I thought we used this one for new files:

 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

Or maybe it doesn't matter.
Comment 5 Dave Hyatt 2015-10-15 16:56:32 PDT
Fixed in r191151.
Comment 6 yisibl 2015-12-13 23:18:12 PST
http://trac.webkit.org/changeset/191151